Skip to main content

ExDSA

Those basic cryptography operations allow the calculation and verify ExDSA signatures. ECDSA and EdDSA are supported.

Allowed usersUser✓Master✗ExtAuth✓
Required access scopekeymgmt:use:<KID>

where <KID> is a Key ID as a 32-character hexadecimal string

Sign​

Sign a message​

POSThttps://my.ence.do/api/crypto/exdsa/sign

Return a signature of the given message.

Headers​

NameTypeDescription
Authorization*StringBearer JWT_TOKEN
Content-Type*Stringapplication/json

Request Body​

NameTypeDescription
alg*StringAlgorithm to use (e.g. Ed25519ctx)
ctxStringBase64 encoded additional context data
msg*StringData message to sign (max. 2048 bytes)
kid*StringKey ID, 32 chars hex string

Response status code​

{
"sign": "4IzdVAZlsNHaUXGNaPMUg139TwnW5QB7WvVKAMEFnHF3JT122JTTnCHuZ1Z6sc2Hvz3WETWJ0ePKUVRJ5HzxDQ=="
}

Possible alg values​

AlgorithmDescription
SHA256WithECDSARegarding NIST SP 800-186
SHA384WithECDSARegarding NIST SP 800-186
SHA512WithECDSARegarding NIST SP 800-186
Ed25519Regarding RFC8032 Section-5.1
Ed25519phRegarding RFC8032 Section-5.1
Ed25519ctxRegarding RFC8032 Section-5.1
Ed448Regarding RFC8032 Section-5.2
Ed448phRegarding RFC8032 Section-5.2

Response data for successful operation​

NameTypeDescription
signStringBase64 encoded signature

Log entries​

EventResultSource
LOG_TYPE_FAILED_SCOPE_CHECKLOG_RESULT_FAILED403
LOG_TYPE_CRYPTO_EXDSA_SIGNLOG_RESULT_ERROR400
LOG_TYPE_CRYPTO_EXDSA_SIGNLOG_RESULT_FAILED406
LOG_TYPE_CRYPTO_EXDSA_SIGNLOG_RESULT_OK200

Verify​

Verify the message signature​

POSThttps://my.ence.do/api/crypto/exdsa/verify

Verify the signature of the given message.

Headers​

NameTypeDescription
Authorization*StringBearer JWT_TOKEN
Content-Type*Stringapplication/json

Request Body​

NameTypeDescription
alg*StringAlgorithm to use (e.g. Ed25519ctx)
ctxStringBase64 encoded additional context data
kid*StringKey ID, 32 chars hex string
msg*StringData message to verify (max. 2048 bytes)
sign*StringSignature to validate return by sign

Response status code​

No response body.

Possible alg values​

Check the list here.

Log entries​

EventResultSource
LOG_TYPE_FAILED_SCOPE_CHECKLOG_RESULT_FAILED403
LOG_TYPE_CRYPTO_EXDSA_VERIFYLOG_RESULT_ERROR400
LOG_TYPE_CRYPTO_EXDSA_VERIFYLOG_RESULT_FAILED406
LOG_TYPE_CRYPTO_EXDSA_VERIFYLOG_RESULT_OK200